#include <stdio.h>
typedef struct cvor *POKAZIVAC;
typedef struct cvor{
	int broj;
	POKAZIVAC sledeci;
}CVOR;
typedef struct glavaRep {
	POKAZIVAC glava;
	POKAZIVAC rep;
}*LISTA;
void inicijalizuj_listu(LISTA *lista){
	(*lista) = malloc(sizeof(CVOR));
	(*lista)->glava = NULL;
	(*lista)->rep = NULL;
}
void ubaci_na_kraj_II(LISTA lista, int broj){
	POKAZIVAC novi_cvor;
	novi_cvor = malloc(sizeof(CVOR));
	novi_cvor->broj = broj;
	novi_cvor->sledeci = NULL;
	if(lista->glava == NULL){
		lista->glava = novi_cvor;
		lista->rep = novi_cvor;
	} else {
		lista->rep->sledeci = novi_cvor;
		lista->rep = novi_cvor;
	}
}
void prebaci_iz_niza_u_listu(LISTA lista, int niz[], int n){
	int i;
	for(i = 0; i < n; i++){
		ubaci_na_kraj_II(lista, niz[i]);
	}
}
POKAZIVAC pronadji_element(LISTA lista, int broj){
	POKAZIVAC tek = lista->glava;
	while(tek != NULL && tek->broj != broj){
		tek = tek->sledeci;
	}
	return tek;
}
int broj_pojavljivanja_u_nizu(int niz[], int n, int broj){
	int i, brojac = 0;
	for(i = 0; i < n; i++){
		if(niz[i] == broj){
			brojac++;
		}
	}
	return brojac;
}
void prebaciKojiSePojavljujuDvaIliVisePuta(LISTA lista, int niz[], int n){
	int i;
	for(i = 0; i < n; i++){
		if(broj_pojavljivanja_u_nizu(niz, n, niz[i]) >= 2 && pronadji_element(lista, niz[i]) == NULL){
			ubaci_na_kraj_II(lista, niz[i]);
		}
	}
}

void razlika_niza_i_liste(LISTA lista, LISTA novaLista, int niz[], int n){
	int i;
	for(i = 0; i < n; i++){
		if(pronadji_element(lista, niz[i]) == NULL){
			ubaci_na_kraj_II(novaLista, niz[i]);
		}
	}
}
void prikazi_listu(LISTA lista){
	POKAZIVAC tek = lista->glava;
	printf("LISTA:\n");
	while(tek != NULL){
		printf("%3d\t", tek->broj);
		tek = tek->sledeci;
	}
	printf("\n");
}
int main(){
	LISTA lista;
	LISTA novaLista;
	int niz[] = {1, 2, 2, 4, 2, 6, 4};
	int n = 7;
	inicijalizuj_listu(&lista);
	inicijalizuj_listu(&novaLista);

	prebaci_iz_niza_u_listu(lista, niz, n);

	prebaciKojiSePojavljujuDvaIliVisePuta(lista, niz, n);

	// Ako sam dobro razumio trazi se razlika niza i liste (Samo oni elementi koji se nalaze u nizu a ne u listi)
	razlika_niza_i_liste(lista, novaLista, niz, n);

	prikazi_listu(lista);
	prikazi_listu(novaLista);
}
